de.caff.gimmicks.swing

## Class CollapsiblePane

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JPanel
        - - de.caff.gimmicks.swing.CollapsiblePane

- All Implemented Interfaces:
    java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, java.util.EventListener, java.util.prefs.PreferenceChangeListener, javax.accessibility.Accessible

      public class CollapsiblePane
      extends javax.swing.JPanel
      implements java.util.prefs.PreferenceChangeListener

  The collapsible content of a `CollapsibleTabbedPane`.
  Since:
    April.28, 2016
  Author:
    Rammi
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.JPanel

      `javax.swing.JPanel.AccessibleJPanel`

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `javax.swing.JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) static java.lang.String` | `I18N_TAG_ACTION_HIDE_EAST`
    `(package private) static java.lang.String` | `I18N_TAG_ACTION_HIDE_NORTH`
    `(package private) static java.lang.String` | `I18N_TAG_ACTION_HIDE_SOUTH`
    `(package private) static java.lang.String` | `I18N_TAG_ACTION_HIDE_WEST`

    - ### Fields inherited from class javax.swing.JComponent

      `listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CollapsiblePane(CollapsibleTabbedPane tabbed, java.lang.String id, java.lang.String title, javax.swing.JComponent internalComponent)` Constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addNotify()`
    `javax.swing.JComponent` | `getInternalComponent()` Get the internal component.
    `java.awt.Dimension` | `getMinimumSize()`
    `java.lang.String` | `getPreferenceKey()` Get the preference key.
    `java.awt.Dimension` | `getPreferredSize()`
    `java.awt.Dimension` | `getSize()`
    `void` | `loadPreferences(java.util.prefs.Preferences preferences)` Load the expanded size from the preferences.
    `void` | `preferenceChange(java.util.prefs.PreferenceChangeEvent evt)`
    `void` | `removeNotify()`
    `(package private) void` | `setExpanded(boolean aFlag)`
    `void` | `storePreferences(java.util.prefs.Preferences preferences)` Store the expanded size to the preferences.

    - ### Methods inherited from class javax.swing.JPanel

      `getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getNextFocusableComponent, getPopupLocation, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### I18N_TAG_ACTION_HIDE_NORTH

          static final java.lang.String I18N_TAG_ACTION_HIDE_NORTH

      See Also:
        Constant Field Values

    - #### I18N_TAG_ACTION_HIDE_EAST

          static final java.lang.String I18N_TAG_ACTION_HIDE_EAST

      See Also:
        Constant Field Values

    - #### I18N_TAG_ACTION_HIDE_SOUTH

          static final java.lang.String I18N_TAG_ACTION_HIDE_SOUTH

      See Also:
        Constant Field Values

    - #### I18N_TAG_ACTION_HIDE_WEST

          static final java.lang.String I18N_TAG_ACTION_HIDE_WEST

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### CollapsiblePane

          CollapsiblePane(@NotNull
                          CollapsibleTabbedPane tabbed,
                          @NotNull
                          java.lang.String id,
                          @NotNull
                          java.lang.String title,
                          @NotNull
                          javax.swing.JComponent internalComponent)

      Constructor.
      Parameters:
        `tabbed` - tabbed pane to which this pane belongs
        `id` - id for preference access
        `title` - title of pane
        `internalComponent` - component which is handle by this collapsible pane

  - ### Method Detail

    - #### getInternalComponent

          @NotNull
          public javax.swing.JComponent getInternalComponent()

      Get the internal component.
      Returns:
        internal component

    - #### addNotify

          public void addNotify()

      Overrides:
        `addNotify` in class `javax.swing.JComponent`

    - #### getPreferredSize

          public java.awt.Dimension getPreferredSize()

      Overrides:
        `getPreferredSize` in class `javax.swing.JComponent`

    - #### getSize

          public java.awt.Dimension getSize()

      Overrides:
        `getSize` in class `java.awt.Component`

    - #### getMinimumSize

          public java.awt.Dimension getMinimumSize()

      Overrides:
        `getMinimumSize` in class `javax.swing.JComponent`

    - #### setExpanded

          void setExpanded(boolean aFlag)

    - #### getPreferenceKey

          @NotNull
          public java.lang.String getPreferenceKey()

      Get the preference key.
      Returns:
        preference key

    - #### removeNotify

          public void removeNotify()

      Overrides:
        `removeNotify` in class `javax.swing.JComponent`

    - #### loadPreferences

          public void loadPreferences(@NotNull
                                      java.util.prefs.Preferences preferences)

      Load the expanded size from the preferences.
      Parameters:
        `preferences` - preferences

    - #### storePreferences

          public void storePreferences(@NotNull
                                       java.util.prefs.Preferences preferences)

      Store the expanded size to the preferences.
      Parameters:
        `preferences` - preferences

    - #### preferenceChange

          public void preferenceChange(java.util.prefs.PreferenceChangeEvent evt)

      Specified by:
        `preferenceChange` in interface `java.util.prefs.PreferenceChangeListener`